<?php
//defined('BASEPATH') OR exit('No direct script access allowed');

class Logdetails extends CI_Controller {
	public function __construct() 
    {
        parent::__construct();
        /*if(!$this->session->userdata("userdata")) {
        redirect(base_url());
            // do something
        }
        $this->load->library("pagination");*/
    }

    public function index($offset = 0){

    	$offset = ($this->uri->segment(3) != '' ? $this->uri->segment(3): 0);
        $ip  = @$this->input->get('ip');
        $url = @$this->input->get('url');
        $anytext = @$this->input->get('any');
        if($ip || $url || $anytext){
           $search_param = array(
                'ip'  => trim($ip),
                'url' => trim($url),
                'anytext' => trim($anytext)
            );
            $total_log = $this->total_log($search_param);
            $resulted_data = $this->get_logs(25, $offset,$search_param);
           
        }
        else{
            $total_log = $this->total_log();
            $resulted_data = $this->get_logs(25, $offset);
        }
        
        
        $config['total_rows'] = $total_log;
        $config['per_page']= 25;
        $config['first_link'] = 'First';
        $config['last_link'] = 'Last';
        $config['uri_segment'] = 3;
        $config["full_tag_open"] = '<ul class="pagination">';
        $config["full_tag_close"] = '</ul>';    
        $config["first_link"] = "&laquo;";
        $config["first_tag_open"] = "<li>";
        $config["first_tag_close"] = "</li>";
        $config["last_link"] = "&raquo;";
        $config["last_tag_open"] = "<li>";
        $config["last_tag_close"] = "</li>";
        $config['next_link'] = '&gt;';
        $config['next_tag_open'] = '<li>';
        $config['next_tag_close'] = '<li>';
        $config['prev_link'] = '&lt;';
        $config['prev_tag_open'] = '<li>';
        $config['prev_tag_close'] = '<li>';
        $config['cur_tag_open'] = '<li class="active"><a href="#">';
        $config['cur_tag_close'] = '</a></li>';
        $config['num_tag_open'] = '<li>';
        $config['num_tag_close'] = '</li>';
        $config['base_url']= base_url().'index.php/logdetails/index'; 
        $config['suffix'] = '?'.http_build_query($_GET, '', "&"); 
        $this->pagination->initialize($config);
        $data['paginglinks'] = $this->pagination->create_links();
            // Showing total rows count 
        if($data['paginglinks']!= '') {
          $data['pagermessage'] = 'Showing '.((($this->pagination->cur_page-1)*$this->pagination->per_page)+1).' to '.($this->pagination->cur_page*$this->pagination->per_page).' of '.$total_log;
        }   
        $data['logs'] = $resulted_data;  
        $data['heading_title'] = "Log details";
    	$this->load->view('header',$data);
		$this->load->view('navbar');
    	$this->load->view('loglist');
    	$this->load->view('footer');
    }
    
    public function generate_csv(){
        $this->load->dbutil();
        $this->load->helper('file');
        $this->load->helper('download');
        $filename="report.csv";
        //var_dump($this->input->post());exit();
        $param_ip=trim(@$this->input->get('ip'));
        $param_url=trim(@$this->input->get('url'));
        $param_any=trim(@$this->input->get('any'));
        $this->db->select('user_log.ciaddr,user_log.url,user_log.date_time');
        $this->db->from('user_log');
        if(isset($param_any) && $param_any!=""){
            $this->db->where("url like '%$param_any%'");
            $this->db->or_where("date_time like '%$param_any%'");
            $this->db->or_where("ciaddr like '%$param_any%'");
        }
        else{
            if(isset($param_ip) && $param_ip!=""){
                $this->db->where("ciaddr like '%$param_ip%'");
            }
            if(isset($param_url) && $param_url!=""){
                $this->db->where("url like '%$param_url%'");
            }

        }
        $query = $this->db->get();  
        $delimiter = ",";
        $newline = "\r\n";
        $data= $this->dbutil->csv_from_result($query, $delimiter, $newline);
        force_download($filename, @$data);
        
    }
    private function total_log($search_param="") {
       $sql = "SELECT COUNT('id') AS `numrows` FROM `user_log`";
       if(isset($search_param['anytext']) && $search_param['anytext']!=""){
            $anytext = $search_param['anytext'];
            $sql = $sql. " where url like '%$anytext%' or date_time like '%$anytext%' or ciaddr like '%$anytext%' ";
        }
        else{
            if(isset($search_param['ip'])){
                $ip = $search_param['ip'];
                $sql= $sql." where ciaddr like '%$ip%'";
            }
            if(isset($search_param['url'])){
                $url = $search_param['url'];
                $sql =$sql." AND url like '%$url%'";
            }
        }
       
        
        $s = $this->db->query($sql)->result_array();

       return $s[0]['numrows'];
    }
    private function get_logs($limit, $start,$search_param="") {
      
      $this->db->select('user_log.ciaddr,user_log.url,user_log.date_time');
        $this->db->from('user_log');
        if(isset($search_param['anytext']) && $search_param['anytext'] !=""){
            $anytext = $search_param['anytext'];
            $this->db->where("url like '%$anytext%'");
            $this->db->or_where("date_time like '%$anytext%'");
            $this->db->or_where("ciaddr like '%$anytext%'");
        }
        else{
            if(isset($search_param['ip']) && $search_param['ip']!=""){
                $ip = $search_param['ip'];
                $this->db->where("ciaddr like '%$ip%'");
            }
            if(isset($search_param['url']) && $search_param['url'] !=""){
                $url = $search_param['url'];
                $this->db->where("url like '%$url%'");
            }
        }
        $this->db->limit($limit, $start);
        $query = $this->db->get();
        echo $this->db->last_query();
        if ($query->num_rows() > 0) {
         return $query->result_array();
      }
      return false;
   }
}