<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Planner extends CI_Controller {
    public function __construct() 
    {
        parent::__construct();
        $this->load->library('Multiquery');  
    }
    public function planlist($user_id,$status){
        $spn = "Call ptsl_sp_get_plans('".$user_id."' , '".$status."')";
        $this->db->query($spn)->result_array();
        $data = $this->multiquery->GetResults($spn);
        //print_r($data);
        if($data){
            $response = array(
                'status' => TRUE,
                'planners' => $data[2]
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        } 
    }
    public function get_planlist_calender(){
        $date = $this->input->get('date');
        $user_id = $this->input->get('user_id');
        $supplier = @$this->input->get('brand');
        $status = @$this->input->get('status');
        $channel = @$this->input->get('channel');
        $spn = "Call ptsl_sp_get_plan_list_by_date('".$user_id."' , '".$date."','".$supplier."','".$status."','".$channel."')";
        //$data = $this->db->query($spn)->result_array();
        //echo $spn;
        $data = $this->multiquery->GetResults($spn);
        //print_r($data);
        if($data){
            $response = array(
                'status' => TRUE,
                'planners_am' => $data[3],
                'planners_pm' => $data[4]
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        } 
    }
    public function get_map_data($user_id,$status){
        $ismap = 1;
        $spn = "Call ptsl_sp_get_plans('".$user_id."' , '".$status."')";
        $this->db->query($spn)->result_array();
        $data_arr = $this->multiquery->GetResults($spn);
        $cnt = 0;
        $len=count($data_arr[2]);
        foreach($data_arr[2] as $key => $account){
            $name = @$account['LongName'];
            $loc = @$account['full_address'];
                $link = '<div class="sum2">'.'<a href="#/clientresult/'.$account["account_id"].'">Go to Account</a></div>';
                $geocode_array[$cnt][0] = '<div class="summary"><a href="#/clientresult/'.$account["account_id"].'">'.$name.'</a></div>'.'<br /><br/>'.$loc.'<br/><br />'.$link;
                $geocode_array[$cnt][1] = $account['latitude'];
                $geocode_array[$cnt][2] = $account['longitude'];
                $cnt++;
        }
        if(@$geocode_array){
             $response = array(
                'status' => TRUE,
                'locations' => $geocode_array
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function getaccountname($id){
        $this->db->select('LongName');
        $data = $this->db->get_where('ptsl_accountinfo',array('AccountID'=>$id))->result_array();
        if($data){
            $response = array(
                'status' => TRUE,
                'name' => $data[0]['LongName']
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        } 
    }
    public function save(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        $array = array(
            'account_id' => @$post_data['acc_id'],
            'plan' => @$post_data['plan'],
            'user_id' => @$post_data['user_id'],
            'plan_date' => @$post_data['date'],
            'supplier_id' =>@$post_data['supplier_id'],
            'date_created'=> date('Y-m-d H:i:s'),
            'time_period' => @$post_data['period'] 
        );
        $res = $this->db->insert('ptsl_account_plans',$array);
        if($res){
            $response = array(
                'status' => TRUE,
                'message' => 'Plan Added Successfully'
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        } 
    }
    public function details($id,$user_id){
       $this->db->select('*');
        $data = $this->db->get_where('ptsl_vw_get_plans',array('plan_id'=>$id))->row();
        $spn= "call ptsl_get_desitributors_for_plan ('".$id."','".$user_id."')";
        $participants = $this->multiquery->GetResults($spn); 
        if($data){
            $response = array(
                'status' => TRUE,
                'plan_details' => $data,
                'participants_names' => $participants[0][0]['participants'],
                'can_join' => $participants[2][0]
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }  
    }
    public function join($plan_id,$user_id){

        $res = $this->db->insert('ptsl_distributor_plan',array('plan_id'=> $plan_id,'distributor_user_id'=>$user_id,'date_created'=>date('Y-m-d H:i:s')));
        if($res){
            $response = array(
                'status' => TRUE,
                'message' => 'Joined'
            );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => FALSE,
                'message' => 'No data Found'
            );
            echo json_encode($response);
        }  
    } 
}