<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Supplier extends CI_Controller {
    public function __construct() 
    {
    	error_reporting(1);
        parent::__construct();  
        $this->load->library('Multiquery'); 
    }
    public function supplier_list(){
    	$user_id = $this->input->get('user_id');
    	$account_id = $this->input->get('account_id');
    	$spn = "Call ptsl_sp_get_suppliers_for_account('".$user_id."','".$account_id."')";
    	$data = $this->db->query($spn)->result_array();
    	if($data){
    	    $response = array(
    	         'status' => TRUE,
    	         'list' => $data
    	        );
    	    echo json_encode($response);
    	}
    	else{
    	    $response = array(
    	        'status' => False,
    	         'message' => "No Data Found"
    	    );
    	    echo json_encode($response);
    	}
    }
    public function supplier_search(){
        $post_data = json_decode(file_get_contents('php://input'), true);
        $user_id = @$post_data['user_id'];
        $prefix = @$post_data['prefix'];
        $spn = "Call ptsl_sp_search_supplier('".$user_id."','".$prefix."')";

        $data = $this->db->query($spn)->result_array();
        if($data){
            $response = array(
                 'status' => TRUE,
                 'list' => $data
                );
            echo json_encode($response);
        }
        else{
            $response = array(
                'status' => False,
                 'message' => "No Data Found"
            );
            echo json_encode($response);
        }
    }
    public function get_accounts(){
        $post = json_decode(file_get_contents('php://input'), true);
        $prefix= @$post['key'];
        $supplier = @$post['supplier'];
        $distributor =@$post['distributor'];
        $spn = "Call ptsl_sp_search_account_with_sr(?,?,?)";
        $data = $this->db->query($spn,array($supplier,$distributor,$prefix))->result_array();
        if($data){
             $response = array(
                'status' => TRUE,
                'users' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function saveping(){
      $post_data = json_decode(file_get_contents('php://input'), true);
      //$post_data = $this->input->post();
      $sup_id = $post_data['supplier'];
      $account_id = $post_data['account'];
      $note = $post_data['note'];
      $user_id = $post_data['user_id'];
      $ping_init ="";
      $spn = "Call ptsl_sp_ping_user_info('".$user_id."','".$account_id."','".$sup_id."','".$ping_init."')";

      $data = $this->multiquery->GetResults($spn);

      $ping_data = $data[1][0];
      //print_r($ping_data);
      //$spn = "call ptsl_sp_get_device_key('".$ping_data['receiver_user_id']."')";
      $spl = "select device_key from ptsl_push_notifications where user_id='".$ping_data['receiver_user_id']."'";
      $devices = $this->db->query($spl)->result_array(); 
      //print_r($devices);// exit;
      if(!$devices){
        $response = array(
            'status' => False,
          );
          echo json_encode($response);
          return;
      }else{
        $res = $this->db->insert('ptsl_ping_header',$ping_data); 
      //print_r($res);
      if($res){
        $ping_id = $this->db->insert_id();
        $reciver_id = $ping_data['receiver_user_id'];
        $func = "select ptsl_fn_get_user_info('".$user_id."', 'name') as sender_name";
        $resulted_name = $this->db->query($func)->row();
        $sender_name = $resulted_name->sender_name;
        $push_mmsg = "You've got a ping from ".$sender_name.".";
        $pingdata_details_table = array(
          'ping_id' => $ping_id,
          'ping_content'=> $note,
          'ping_by' => $user_id
        );
        $this->db->insert('ptsl_ping_detail',$pingdata_details_table);
        $notification_data= array(
            'user_id' => $reciver_id,
            'notification' => $push_mmsg,
            'notification_url' => '#/pingdetails/'.$ping_id,
            'created_date' => date('Y-m-d H:i:s')
        );
        $res2 = $this->db->insert('ptsl_user_notifications',$notification_data);
        //print_r($res); 
        $device_array = array();
        if($res2){
          foreach ($devices as $key => $device) {
            # code...
            array_push($device_array, $device['device_key']);
          }
         // print_r($device_array);
          $this->send_push($device_array,$ping_id,$push_mmsg);
        }
        $response = array(
            'status' => TRUE,
            'message' => "Ping Created Successfully"
          );
          echo json_encode($response);
      }
      else{
          $response = array(
            'status' => False,
            'message' => "No Data Found"
          );
        echo json_encode($response);
        } 
      }
      
    }
    public function updateping(){
      $post_data = json_decode(file_get_contents('php://input'), true);
      $sup_id = $post_data['supplier'];
      $account_id = $post_data['account'];
      $note = $post_data['note'];
      $user_id = $post_data['user_id'];
      $ping_id =$post_data['ping_id'];
      $spn = "Call ptsl_sp_ping_user_info('".$user_id."','".$account_id."','".$sup_id."','".$ping_id."')";
      //echo $spn;
      $data = $this->multiquery->GetResults($spn);
      //print_r($data); exit;
      $ping_data = $data[1][0];
      $this->db->where('ping_id',$ping_id); 
      $res = $this->db->update('ptsl_ping_header',$ping_data); 
      //echo $this->db->last_query(); exit;
      if($res){
        $reciver_id = $ping_data['receiver_user_id'];
        $func = "select ptsl_fn_get_user_info('".$user_id."', 'name') as sender_name";
        $resulted_name = $this->db->query($func)->row();
        $sender_name = $resulted_name->sender_name;
        $push_mmsg = "You've got a ping from ".$sender_name.".";
        $pingdata_details_table = array(
          'ping_id' => $ping_id,
          'ping_content'=> $note,
          'ping_by' => $user_id
        );
        $this->db->insert('ptsl_ping_detail',$pingdata_details_table);
        $notification_data= array(
            'user_id' => $reciver_id,
            'notification' => $push_mmsg,
            'notification_url' => '#/pingdetails/'.$ping_id,
            'created_date' => date('Y-m-d H:i:s')
        );
        $res2 = $this->db->insert('ptsl_user_notifications',$notification_data);
        $device_array = array();
        if($res2){
          $spn = "call ptsl_sp_get_device_key('".$reciver_id."')";
          $devices = $this->db->query($spn)->result_array();
          array_push($device_array, $devices[0]['device_key']);
          $this->send_push($device_array,$ping_id,$push_mmsg);
        }
        $response = array(
            'status' => TRUE,
            'message' => "Ping Created Successfully"
          );
          echo json_encode($response);
      }
      else{
          $response = array(
            'status' => False,
            'message' => "No Data Found"
          );
        echo json_encode($response);
        } 
    }
    public function ping_list(){
        $user_id = $this->input->get('user_id');
        $sp = "Call ptsl_sp_get_ping_list('".$user_id."')";
        //$data = $this->multiquery->GetResults($sp);
        $data = $this->db->query($sp)->result_array();
        if($data){
             $response = array(
                'status' => TRUE,
                'list' => $data
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function ping_status(){
      $user_id = $this->input->get('user_id');
      $fnc = "select ptsl_fn_view_permission('".$user_id."', 'add_ping') as can_ping";
      $row = $this->db->query($fnc)->row();
      if($row){
             $response = array(
                'status' => TRUE,
                'can_ping' => $row->can_ping
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function ping_details(){
      $user_id = $this->input->get('user_id');
      $ping_id = $this->input->get('ping_id');
      $spn = "Call ptsl_sp_get_ping_details('".$user_id."', '".$ping_id."')";
      //$data = $this->db->query($spn)->result_array();
      $data = $this->multiquery->GetResults($spn);
      if($data){
             $response = array(
                'status' => TRUE,
                'pingdetails' => $data[0],
                'comments' =>$data[1]
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    private function send_push($devices_associative_arr,$id,$msg){
        $devices =array();
        $devices = $devices_associative_arr;
        $content = array(
          "en" => $msg
          );
        
       $fields = array(
      'app_id' => "e13a6f2b-74f2-4cb8-a109-b4af95c293ce",
     // 'included_segments' => array('All'),
      //'included_segments' => array('789e714d-7e95-4a1f-a65c-75f967f442a3'),
      'include_player_ids' => $devices,
      'data' => array("state" => "pingdetails","param"=>$id,"type_id"=>4),
      'contents' => $content,
      "ios_badgeType" => "Increase",
      "ios_badgeCount"=> 1
  

    );
        
        $fields = json_encode($fields);
       // print("\nJSON sent:\n");
        //print($fields);
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://onesignal.com/api/v1/notifications");
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json; charset=utf-8',
                               'Authorization: Basic OTQ0YWM4ODQtNjNjZi00MzJjLThhMjgtZjdiZTcyYWY3YTJl'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

        $response = curl_exec($ch);
        curl_close($ch);
        
        return $response;
    } 
}